#include <csignal>
#include <iostream>

#include "../include/FileUtils.h"
#include "../include/WordUtils.h"
#include "../include/ServerUtils.h"
#include "../include/ConcurrentQueue.h"
#include "../include/TrackerUtils.h"
#include "../include/Track.h"
#include "../include/MetricsExporter.h"

using namespace std;

int main(int argc, const char* argv[]) {
    /*if (argc > 2)
    {
        cout << "Too many arguments";
        return 0;
    }
    
    if (!FileUtils::fileExists(argv[1]))
    {
        cout << "Filepath: " << argv[1] << " doesn't exist.";
        return 0;
    }*/

    cout << "lol" << endl;

    auto queue = std::make_shared<ConcurrentQueue<Track>>();
    auto metrics = std::make_shared<unordered_map<uint32_t, Crawler>>();

    thread(TrackerUtils::track, queue, metrics).detach();

    thread(MetricsExporter::serve, metrics).detach();

    //argv[1]
    signal(SIGPIPE, SIG_IGN);
    ServerUtils::serve(queue);

    return 0;
}